wok annotate syslinux/stuff/iso2exe/taziso @ rev 20771

cpige: add man page for cook.slitaz.org
author Pascal Bellard <pascal.bellard@slitaz.org>
date Wed Feb 13 16:56:42 2019 +0100 (23 months ago)
parents 378b0ba41272
children 02c70d036ea0
rev   line source
pascal@17635 1 #!/bin/sh
pascal@17635 2
pascal@17635 3 [ $(id -u) -eq 0 ] || exec su -c "$0 $@"
pascal@17635 4
pascal@17635 5 DIALOG=dialog
pascal@17635 6
pascal@17635 7 ddq()
pascal@17635 8 {
pascal@17635 9 dd $@ 2> /dev/null
pascal@17635 10 }
pascal@17635 11
pascal@17635 12 get()
pascal@17635 13 {
pascal@18670 14 od -v -j $1 -N ${4:-${3:-2}} -t u${3:-2} -w${3:-2} -An "$2" 2>/dev/null ||
pascal@18670 15 hexdump -v -s $1 -n ${4:-${3:-2}} -e "\"\" 1/${3:-2} \" %d\n\"" "$2"
pascal@17635 16 }
pascal@17635 17
pascal@17635 18 bytes2bin()
pascal@17635 19 {
pascal@17635 20 for i in $@ ; do
pascal@17635 21 printf '\\\\x%02X' $(($i&255))
pascal@17635 22 done | xargs echo -en
pascal@17635 23 }
pascal@17635 24
pascal@17635 25 words2bin()
pascal@17635 26 {
pascal@17635 27 for i in $@ ; do
pascal@17635 28 printf '\\\\x%02X\\\\x%02X' $(($i&255)) $((($i>>8)&255))
pascal@17635 29 done | xargs echo -en
pascal@17635 30 }
pascal@17635 31
pascal@17635 32 gettazboot()
pascal@17635 33 {
pascal@17635 34 echo "Creating $(basename $1) ..."
pascal@18670 35 O=$(($(get 64 "$ISO") - 0xC0))
pascal@18670 36 L=$(($(get 20 "$ISO") - 0xC0 - $(get 24 "$ISO") - $O))
pascal@18140 37 S=$((32+$L))
pascal@18140 38 P=$((($S+511)/512))
pascal@18140 39 E=$((4096-(32*$P)))
pascal@18140 40 words2bin 0x5A4D $(($S%512)) $P 0 2 $E -1 $((${2:-0}-16)) \
pascal@18140 41 -2 0 256 -16 28 0x6C53 0x5469 0x7A61 > $1
pascal@18670 42 ddq bs=1 count=$L skip=$(echo $O) if="$ISO" >> $1
pascal@17635 43 }
pascal@17635 44
pascal@17635 45 uncpio()
pascal@17635 46 {
pascal@17635 47 [ -s "$1" ] || return
pascal@17635 48 echo -en "\n Extracting $(basename $1) ..."
pascal@17635 49 case $(get 0 $1) in
pascal@17635 50 *35615) ( zcat || gunzip ) ;;
pascal@17635 51 *14333) unxz ;;
pascal@17635 52 *\ 93) unlzma ;;
pascal@17635 53 *) cat ;;
pascal@17635 54 esac < $1 | ( cd ${2:-/} ; cpio -idmu > /dev/null 2>&1 )
pascal@17635 55 }
pascal@17635 56
pascal@17635 57 dotwait()
pascal@17635 58 {
pascal@17635 59 echo -n "${1:-Install filesystem}.."
pascal@17635 60 touch /tmp/wait
pascal@17930 61 [ "$REQUEST_URI" ] && return
pascal@17635 62 while [ -e /tmp/wait ]; do
pascal@17635 63 echo -n "." > /dev/tty
pascal@17635 64 sleep 1
pascal@17635 65 done &
pascal@17635 66 }
pascal@17635 67
pascal@17635 68 getuuid()
pascal@17635 69 {
pascal@17635 70 dev=$(mount | sed "/ $(echo $mnt | sed 's|/|\\/|g') /!d;s/ .*//;s|/dev/||;q")
pascal@17635 71 [ "$dev" ] &&
pascal@17635 72 blkid | sed "/$dev:/!d;s/.* UUID=.\\([^ ]*\\)\".*/\\1/" ||
pascal@17635 73 echo "/dev/hda1"
pascal@17635 74 }
pascal@17635 75
pascal@17635 76 tazusbinitfs()
pascal@17635 77 {
pascal@17635 78 PAD=$(($(stat -c %s $1) % 4))
pascal@17635 79 [ $PAD -ne 0 ] && ddq if=/dev/zero bs=1 count=$((4 - $PAD)) >> $1
pascal@17635 80 mkdir -p /tmp/fs$$/etc /tmp/fs$$/lib /tmp/fs$$/home
pascal@17635 81 cp -a /etc/locale.conf /tmp/fs$$/etc 2> /dev/null
pascal@17635 82 cp -a /etc/keymap.conf /tmp/fs$$/etc 2> /dev/null
pascal@17635 83 cat > /tmp/fs$$/init1 <<EOT
pascal@17635 84 #!/bin/sh
pascal@17635 85 sed -i 's|sbin/init|init2|' /init
pascal@17635 86 exec /init
pascal@17635 87 EOT
pascal@17635 88 cat > /tmp/fs$$/init2 <<EOT
pascal@17635 89 #!/bin/sh
pascal@17635 90
pascal@17635 91 mount -t proc /proc /proc
pascal@17635 92 for i in /lib/*.ko* ; do insmod \$i 2> /dev/null ; done; sleep 2
pascal@17635 93 v=\$(sed '/\\/home=/!d;s|.*/home=\\([^ ]*\\).*|\\1|' /proc/cmdline /cmdline 2> /dev/null)
pascal@17635 94 mount / -o remount,rw
pascal@17635 95 mkdir /mnt/dos
pascal@17635 96 rm -f /cmdline 2> /dev/null
pascal@17635 97 mount / -o remount,ro
pascal@17635 98 mnt=/mnt/dos/\${v#*/}
pascal@17635 99 dev=\$( (blkid /dev/[sh]d* || blkid) | grep \${v%%/*} | sed 's/:.*//;q')
pascal@17635 100 echo "Mount \$dev in /mnt/dos for \$v..." | tee -a /run/boot.log
pascal@17635 101 mount \$dev /mnt/dos
pascal@17635 102 if [ ! -d /mnt/dos/slitaz ]; then
pascal@17635 103 umount /mnt/dos 2> /dev/null
pascal@17635 104 (blkid /dev/[sh]d* || blkid) | while read dev line; do
pascal@17635 105 case "\$line" in
pascal@17635 106 *ntfs*|*vfat*|*msdos*) ;;
pascal@17635 107 *) continue ;;
pascal@17635 108 esac
pascal@17635 109 mount \${dev%:} /mnt/dos
pascal@17635 110 [ -d /mnt/dos/slitaz ] && break
pascal@17635 111 umount /mnt/dos
pascal@17635 112 done
pascal@17635 113 fi
pascal@17932 114 $([ "$2" ] || echo '# ')mount.posixovl -F \$mnt -- -oallow_other -odefault_permissions -osuid
pascal@17635 115 mount --bind \$mnt /home
pascal@17635 116 umount /proc
pascal@17635 117 exec /sbin/init
pascal@17635 118 EOT
pascal@17635 119 chmod 755 /tmp/fs$$/init?
pascal@17635 120 ( cd /tmp/fs$$ ; find * | cpio -o -H newc ) | gzip -9 >> $1
pascal@17635 121 rm -rf /tmp/fs$$
pascal@17635 122 }
pascal@17635 123
pascal@17635 124 mkinitrd()
pascal@17635 125 {
pascal@17635 126 echo -en "\nCreating $(basename $1) "
pascal@17635 127 fs=/tmp/fs$$
pascal@17635 128 for i in bin lib dev proc tmp mnt etc ; do
pascal@17635 129 mkdir -p $fs/$i
pascal@17635 130 done
pascal@17635 131 for i in /dev/console /dev/null /dev/tty /dev/tty0 /dev/tty1 /dev/tty2 \
pascal@17635 132 /dev/fuse /dev/hd* /dev/sd* ; do
pascal@17635 133 cp -a $2$i $fs/dev/
pascal@17635 134 done
pascal@17635 135 for i in /bin/busybox $(which mount.posixovl) $(which blkid); do
pascal@17635 136 cp $(LD_TRACE_LOADED_OBJECTS=1 /lib/ld*.so $i | \
pascal@17635 137 sed 's|.*=> \(.*/lib/l[^ ]*\).*|\1|;/^\//!d') $fs/lib
pascal@17635 138 cp $i $fs/bin
pascal@17635 139 done
pascal@17635 140 cp -a /lib/ld-* $fs/lib
pascal@17635 141 for i in $(busybox | sed '/Current/,$!d'); do
pascal@17635 142 [ -e $fs/bin/${i%,} ] || ln -s busybox $fs/bin/${i%,}
pascal@17635 143 done
pascal@17635 144 ln -s /proc/mounts $fs/etc/mtab
pascal@17635 145 sed 's/ .*//' /proc/modules | while read mod ; do
pascal@17635 146 find /lib/modules/ | grep $mod.ko | \
pascal@17635 147 sed 's|.*|cp & $fs/lib|' | sh
pascal@17635 148 done
pascal@17635 149 cat > $fs/init <<EOT
pascal@17635 150 #!/bin/sh
pascal@17635 151
pascal@17635 152 arg()
pascal@17635 153 {
pascal@17635 154 grep -q \$1 /proc/cmdline &&
pascal@17635 155 val="\$(sed "s/.*\$1=\\([^ ]*\\).*/\\1/" < /proc/cmdline)" &&
pascal@17635 156 echo "\$2 \$val"
pascal@17635 157 }
pascal@17635 158
pascal@17635 159 mount -t proc /proc /proc
pascal@17635 160 arg debug "shell" && debug=true && set -x
pascal@17635 161 for i in /lib/*.ko* ; do insmod \$i 2> /dev/null ; done; sleep 2
pascal@17635 162 arg mount "Mount device"
pascal@17635 163 mount \$( (blkid /dev/[sh]d* || blkid) | grep \$val | sed 's/:.*//;q') /mnt
pascal@17635 164 arg subroot "Change root to directory"
pascal@17635 165 if [ -d /mnt/\$val ]; then
pascal@17635 166 umount /mnt 2> /dev/null
pascal@17635 167 (blkid /dev/[sh]d* || blkid) | while read dev line; do
pascal@17635 168 case "\$line" in
pascal@17635 169 *ntfs*|*vfat*|*msdos*) ;;
pascal@17635 170 *) continue ;;
pascal@17635 171 esac
pascal@17635 172 mount \${dev%:} /mnt
pascal@17635 173 [ -d /mnt/\$val ] && break
pascal@17635 174 umount /mnt
pascal@17635 175 done
pascal@17635 176 fi
pascal@17932 177 $([ "$3" ] || echo '# ')mount.posixovl -F /mnt/\$val -- -oallow_other -odefault_permissions -osuid
pascal@17635 178 mount --bind /mnt /mnt/\$val/mnt/dos
pascal@17635 179 mount -o size=0 -t tmpfs tmpfs /mnt/\$val/mnt/dos/\$val
pascal@17635 180 LDSO=\$(ls /mnt/\$val/lib/ld-* | sed q)
pascal@17635 181 export LD_LIBRARY_PATH=\$val/lib:\$val/usr/lib:/lib
pascal@17635 182 [ "$debug" = "true" ] && sh
pascal@17635 183 umount /proc
pascal@17635 184 exec /bin/switch_root /mnt \${LDSO#/mnt/} \$val/usr/sbin/chroot \$val /sbin/init
pascal@17635 185 EOT
pascal@17635 186 chmod +x $fs/init
pascal@17635 187 ( cd $fs ; find * | cpio -o -H newc ) | lzma e $1 -si 2> /dev/null
pascal@17635 188 rm -rf $fs /tmp/wait
pascal@17635 189 }
pascal@17635 190
pascal@17635 191 ls_r()
pascal@17635 192 {
pascal@17635 193 ls -r $@ 2> /dev/null || ls $@
pascal@17635 194 }
pascal@17635 195
pascal@17635 196 doinstall()
pascal@17635 197 {
pascal@17932 198 unset useposixovl
pascal@17934 199 blkid | grep $(df $mnt | sed '$!d;s/ .*/:/') | \
pascal@17932 200 grep -qiE "(msdos|vfat|ntfs)" && useposixovl=YES
pascal@19029 201 case "$mnt" in
pascal@19029 202 *mkzip*) useposixovl=YES
pascal@19029 203 esac
pascal@17635 204 mkdir -p $mnt/slitaz/boot $mnt/slitaz/mnt/dos
pascal@17932 205 [ "$useposixovl" ] &&
pascal@17635 206 if ! mount.posixovl -F $mnt/slitaz -- \
pascal@17635 207 -oallow_other -odefault_permissions -osuid; then
pascal@17635 208 echo "Can't install SliTaz. Abort."
pascal@17635 209 sleep 5
pascal@17635 210 return 1
pascal@17635 211 fi
pascal@17635 212 dotwait "Install root filesystem in /slitaz.."
pascal@17635 213 if [ "$1" ]; then
pascal@18240 214 ls_r $media/boot/rootfs*gz | \
pascal@17635 215 xargs cat > $mnt/slitaz/boot/rootfs.gz
pascal@17932 216 tazusbinitfs $mnt/slitaz/boot/rootfs.gz $useposixovl
pascal@17635 217 initrd=rootfs.gz
pascal@17635 218 extraargs="/home=$(getuuid)/slitaz rdinit=/init1"
pascal@17635 219 else
pascal@18240 220 for i in $(ls_r $media/boot/rootfs*gz); do
pascal@17635 221 uncpio $i $mnt/slitaz
pascal@17635 222 done
pascal@17635 223 for i in $packages_list; do
pascal@17635 224 tazpkg get-install $i --root=$mnt/slitaz
pascal@17635 225 done
pascal@17635 226 for i in $packages_dir/*.tazpkg; do
pascal@17635 227 [ -s "$i" ] &&
pascal@17635 228 tazpkg install $i --root=$mnt/slitaz
pascal@17635 229 done
pascal@17635 230 cp -a /etc/locale.conf $mnt/slitaz/etc 2> /dev/null
pascal@17635 231 cp -a /etc/keymap.conf $mnt/slitaz/etc 2> /dev/null
pascal@17932 232 mkinitrd $mnt/slitaz/boot/initrd $mnt/slitaz $useposixovl
pascal@17635 233 initrd=initrd
pascal@17635 234 extraargs="mount=$(getuuid) subroot=slitaz"
pascal@17635 235 fi
pascal@17635 236 echo -en "\nInstall boot files..."
pascal@20158 237 for i in $media/boot/bzImage* $media/boot/*pxe* \
pascal@18240 238 $media/boot/isolinux/he* $media/boot/isolinux/opt* \
pascal@18240 239 $media/README $media/boot/memtest* ; do
pascal@17635 240 [ -s $i ] && cp $i $mnt/slitaz/boot
pascal@17635 241 done
pascal@17635 242 for i in $mnt/slitaz/boot/memtest $mnt/slitaz/boot/*pxe* ; do
pascal@17635 243 [ $(get 0 $i 2> /dev/null || echo 0) -eq 23117 ] &&
pascal@17635 244 mv $i $i.exe
pascal@17635 245 done
pascal@20158 246 bzimage=$(cd $mnt/slitaz/boot ; ls bzimage*)
pascal@20158 247 gettazboot $mnt/slitaz/boot/tazboot.exe # autoappend 64 suffix
pascal@17635 248 unix2dos > $mnt/slitaz/boot/tazboot.cmd <<EOT
pascal@17635 249 kernel=/slitaz/boot/bzimage
pascal@17635 250 initrd=/slitaz/boot/$initrd
pascal@17635 251 rw root=/dev/null $extraargs autologin
pascal@17635 252 EOT
pascal@17635 253 unix2dos $mnt/slitaz/boot/he* $mnt/slitaz/boot/opt* \
pascal@17635 254 $mnt/slitaz/boot/README
pascal@17635 255 [ -d $mnt/slitaz/usr/sbin -a ! -x $mnt/slitaz/usr/sbin/mount.posixovl ] &&
pascal@17635 256 cp $(which mount.posixovl) $mnt/slitaz/usr/sbin
pascal@19033 257 if [ "$useposixovl" ] && grep -qs " $mnt " /proc/mounts &&
pascal@17932 258 [ ! -d $mnt/boot/grub ]; then
pascal@17929 259 mkdir -p $mnt/boot/grub
pascal@17930 260 echo -en "\nInstall grub in /boot/grub..."
pascal@17929 261 cp -a /usr/lib/grub/*/* $mnt/boot/grub
pascal@17929 262 cat > $mnt/boot/grub/menu.lst <<EOT
pascal@17929 263 # /boot/grub/menu.lst: GRUB boot loader configuration.
pascal@17929 264
pascal@17929 265 # By default, boot the first entry.
pascal@17929 266 default 0
pascal@17929 267
pascal@17929 268 # Boot automatically after 8 secs.
pascal@17929 269 timeout 8
pascal@17929 270
pascal@17929 271 title Microsoft Windows
pascal@17929 272 chainloader +1
pascal@17929 273
pascal@17929 274 EOT
pascal@17929 275 dev=$(grep " $mnt " /proc/mounts | awk '{ print $1 }')
pascal@17929 276 base=${dev//[0-9]/}
pascal@17929 277 dd if=$base bs=32k count=1 of=$mnt/boot/grub/$(basename $base)
pascal@17929 278 cat > $mnt/boot/grub/uninstall-grub.sh <<EOT
pascal@17929 279 #!/bin/sh
pascal@17929 280
pascal@17929 281 [ -s /boot/grub/$(basename $base) ] &&
pascal@17929 282 dd if=/boot/grub/$(basename $base) of=$base
pascal@17929 283 EOT
pascal@17929 284 grub-install --no-floppy --root-directory=$mnt $base
pascal@17929 285 fi
pascal@17932 286 if [ -s $mnt/boot/grub/menu.lst ] &&
pascal@20158 287 ! grep -q /slitaz/boot/$bzimage $mnt/boot/grub/menu.lst; then
pascal@20158 288 echo -en "\nUpdate /boot/grub/menu.lst..."
pascal@17932 289 cat >> $mnt/boot/grub/menu.lst <<EOT
pascal@17932 290 title SliTaz GNU/Linux $(cat $mnt/slitaz/etc/slitaz-release)
pascal@20158 291 kernel /slitaz/boot/$bzimage rw root=/dev/null $extraargs autologin
pascal@17932 292 initrd /slitaz/boot/$initrd
pascal@17932 293
pascal@17932 294 EOT
pascal@17932 295 fi
pascal@17635 296 rm -f /tmp/wait
pascal@17932 297 [ "$useposixovl" ] && umount $mnt/slitaz
pascal@17635 298 return 0
pascal@17635 299 }
pascal@17635 300
pascal@17635 301 windev()
pascal@17635 302 {
pascal@17924 303 if [ -b "$1" ]; then
pascal@17924 304 device=$1
pascal@17928 305 elif [ "$1" ]; then
pascal@17932 306 echo "Invalid Linux/Windows partition"
pascal@17928 307 return 1
pascal@17924 308 else
pascal@17932 309 DEV="$(blkid | grep -iE "(msdos|vfat|ntfs|ext[234]|xfs|btrfs)" | sed 's/:.*//;s|/dev/||')"
pascal@17924 310 [ "$DEV" ] || return
pascal@17635 311 cat > /tmp/dialog$$ <<EOT
pascal@20771 312 $DIALOG --clear --title " Select your Linux/Windows partition " \
pascal@17932 313 --menu "\nPlease select the Linux/Windows partition according to its known size.
pascal@20771 314 The data will be kept untouched.\n" 17 70 8 \
pascal@17635 315 $(for i in $DEV ; do
pascal@17635 316 label="$(blkid | sed "/$i:/!d;s/.*://;s/[^ ]*UUID=[^ ]* //g;s/LABEL=//")"
pascal@17635 317 echo -n "/dev/$i \"$(($(cat /sys/block/*/$i/size)/2048))MB $label\" "
pascal@17635 318 done)
pascal@17635 319 EOT
pascal@17924 320 exec 3>&1
pascal@17924 321 [ $? -eq 0 ] || return
pascal@17924 322 device=$(. /tmp/dialog$$ 2>&1 1>&3)
pascal@17924 323 exec 3>&-
pascal@17924 324 rm -f /tmp/dialog$$
pascal@17924 325 fi
pascal@17635 326 mnt=/tmp/mnt$$
pascal@17635 327 mkdir -p $mnt && mount $device $mnt
pascal@17635 328 }
pascal@17635 329
pascal@17635 330 extra_packages()
pascal@17635 331 {
pascal@17635 332 packages_list=
pascal@17635 333 packages_dir=
pascal@20771 334 $DIALOG --clear --title " Extra packages " \
pascal@17635 335 --defaultno --yesno \
pascal@20771 336 "Do you want to add extra packages ?" 7 70
pascal@17635 337 [ $? -eq 0 ] || return
pascal@17635 338 [ -s /var/lib/tazpkg/packages.txt ] || tazpkg recharge
pascal@18240 339 if [ -s $media/boot/vmlinuz-$(uname -r) ]; then
pascal@17635 340 cat > /tmp/dialog$$ <<EOT
pascal@20771 341 $DIALOG --clear --title " Select the packages " \
pascal@17635 342 --separate-output \
pascal@17635 343 --cancel-label "Skip" \
pascal@17635 344 --checklist "Please select the packages you want to install. Try with the first letter." \
pascal@18240 345 0 0 0 \\
pascal@17635 346 EOT
pascal@17635 347 awk -F\| '{ printf "%s \"%s\" off ",$1,$3 }' \
pascal@17635 348 /var/lib/tazpkg/packages.desc >> /tmp/dialog$$
pascal@17635 349 sh /tmp/dialog$$ 2> /tmp/dialog.out$$
pascal@17635 350 [ $? -eq 0 ] && packages_list="$(cat /tmp/dialog.out$$)"
pascal@17635 351 fi
pascal@17635 352 cat > /tmp/dialog$$ <<EOT
pascal@17635 353 $DIALOG --clear \
paul@17671 354 --title "Please select the directory with every custom package to install." \
pascal@20771 355 --cancel-label "Skip" --dselect $PWD 13 78
pascal@17635 356 EOT
pascal@17635 357 sh /tmp/dialog$$ 2> /tmp/dialog.out$$
pascal@17635 358 [ $? -eq 0 ] && packages_dir="$(cat /tmp/dialog.out$$)"
pascal@17635 359 rm -f /tmp/dialog$$ /tmp/dialog.out$$
pascal@17635 360 }
pascal@17635 361
pascal@17635 362 _install()
pascal@17635 363 {
pascal@17635 364 extra_packages
pascal@20771 365 $DIALOG --clear --title " SliTaz UMSDOS way installation " \
pascal@17635 366 --yes-label "Install" --yesno \
pascal@17635 367 "\nSliTaz will be installed in the subdirectory \\slitaz of the current
paul@17935 368 Linux/DOS/Windows partition. You can see your files from /mnt/dos.\n\n
pascal@17635 369 You can start SliTaz with \\slitaz\\boot\\tazboot.exe\n\n
pascal@17635 370 To uninstall SliTaz, you have only to remove this directory.
pascal@17635 371 The file \\boot.ini or \\config.sys may be modified too.\n\n
pascal@20771 372 SliTaz may run slowly on the 'UMSDOS way' installation due to the
pascal@17635 373 posixovl filesystem. The 'TAZUSB way' installation runs faster.\n\n
pascal@17635 374 To do a traditional installation with disk partitioning,
pascal@20771 375 start SliTaz Live with the 'SliTaz RAM boot' menu.\n" 19 70
pascal@17635 376 [ $? -eq 0 ] || return
pascal@17635 377 doinstall
pascal@17635 378 }
pascal@17635 379
pascal@17635 380 readtazbootconf()
pascal@17635 381 {
pascal@17635 382 kernel="$(sed '/^kernel=/!d;s/.*=//' $mnt/slitaz/boot/tazboot.cmd)"
pascal@17635 383 initrd="$(sed '/^initrd=/!d;s/.*=//' $mnt/slitaz/boot/tazboot.cmd)"
pascal@17635 384 cmdline="$(sed '/^kernel=/d;/^initrd=/d' $mnt/slitaz/boot/tazboot.cmd)"
pascal@17635 385 }
pascal@17635 386
pascal@17635 387 bootinstalled()
pascal@17635 388 {
pascal@17635 389 [ "$(which kexec)" ] || return
pascal@17635 390 [ -x $mnt/slitaz$1 ] || return
pascal@17635 391 [ -s $mnt/slitaz/boot/tazboot.cmd ] || return
pascal@17635 392 readtazbootconf
pascal@17659 393 kexec -l $kernel --initrd $initrd --command-line "$cmdline" || return
pascal@17635 394 umount $mnt
pascal@17635 395 rm -rf $mnt
pascal@18240 396 quit "kexec -e"
pascal@17635 397 }
pascal@17635 398
pascal@17635 399 mkzip()
pascal@17635 400 {
pascal@17635 401 device=
pascal@17635 402 packages_list=
pascal@17635 403 packages_dir=
pascal@19029 404 mnt=/tmp/mkzipmnt$$
pascal@17635 405 mkdir -p $mnt
pascal@17930 406 $1 $2 || return
pascal@18140 407 for i in bootlace.com grubinst.exe grldr ; do
pascal@18140 408 wget -O $mnt/slitaz/boot/$i http://mirror.slitaz.org/boot/$i
pascal@18140 409 done
pascal@17635 410 readtazbootconf
pascal@17636 411 cat > $mnt/slitaz/boot/menu.lst <<EOT
pascal@17635 412 title SliTaz
pascal@17635 413 kernel $kernel $cmdline
pascal@17635 414 initrd $initrd
pascal@17635 415
pascal@17635 416 EOT
pascal@17635 417 while read file title; do
pascal@17637 418 file=$(ls $mnt/slitaz/boot/*$file* 2> /dev/null)
pascal@17637 419 [ -s "$file" ] && cat >> $mnt/slitaz/boot/menu.lst <<EOT
pascal@17635 420 title $title
pascal@17637 421 kernel ${file#$mnt}
pascal@17635 422
pascal@17635 423 EOT
pascal@17635 424 done <<EOT
pascal@17635 425 memtest MemTest
pascal@17635 426 pxe Web boot
pascal@17635 427 EOT
pascal@17636 428 unix2dos $mnt/slitaz/boot/menu.lst
pascal@17636 429 unix2dos > $mnt/slitaz/boot/install.txt <<EOT
pascal@17659 430 For DOS users (real mode only):
pascal@17659 431
pascal@17659 432 Start SliTaz with \\slitaz\\boot\\tazboot.exe
pascal@17659 433
pascal@17659 434
pascal@17635 435 For NT/2000/XP users:
pascal@17635 436
pascal@17635 437 1- Move the files grldr and menu.lst into the root directory
pascal@17635 438
pascal@17635 439 C:\\> copy \\slitaz\\boot\\grldr \\
pascal@17635 440 C:\\> copy \\slitaz\\boot\\menu.lst \\
pascal@17635 441
pascal@17635 442 2- Remove boot.ini attributes
pascal@17635 443
pascal@17635 444 C:\\> attrib -r -h -s boot.ini
pascal@17635 445
pascal@17635 446 3- Append the following line to boot.init
pascal@17635 447
pascal@17635 448 C:\\grldr="slitaz"
pascal@17635 449
pascal@17635 450 4- Restore boot.ini attributes
pascal@17635 451
pascal@17635 452 C:\\> attrib +r +h +s boot.ini
pascal@17635 453
pascal@17635 454 See http://diddy.boot-land.net/grub4dos/files/README_GRUB4DOS.txt
pascal@18140 455 and http://xpt.sourceforge.net/techdocs/nix/disk/boot/boot07-GrubForDosInfo/ar01s03.html
pascal@17635 456 EOT
pascal@18140 457 ( cd $mnt ; echo 'See \slitaz\boot\install.txt to launch SliTaz.' | \
pascal@18670 458 zip -zr9 $(basename "$ISO" .iso).zip slitaz )
pascal@19033 459 [ "$(which advzip)" ] &&
pascal@19033 460 echo "Recompressing $(basename "$ISO" .iso).zip ..." &&
pascal@19033 461 advzip -z4 $mnt/*.zip
pascal@17635 462 mv $mnt/*.zip .
pascal@19029 463 du -h $PWD/$(basename "$ISO" .iso).zip
pascal@17636 464 umount $mnt
pascal@17636 465 rm -rf $mnt
pascal@17635 466 }
pascal@17635 467
pascal@17635 468 install()
pascal@17635 469 {
pascal@17924 470 windev $1 || return
pascal@17635 471 packages_list=
pascal@17635 472 packages_dir=
pascal@17924 473 if [ "$1" ]; then
pascal@17924 474 doinstall
pascal@17924 475 else
pascal@17924 476 _install && bootinstalled /sbin/init
pascal@17924 477 fi
pascal@17635 478 umount $mnt
pascal@17635 479 rm -rf $mnt
pascal@17635 480 }
pascal@17635 481
pascal@17635 482 inst2zip()
pascal@17635 483 {
pascal@17924 484 if [ "$1" ]; then
pascal@17930 485 mkzip doinstall
pascal@17924 486 else
pascal@17924 487 mkzip _install
pascal@17924 488 fi
pascal@17635 489 }
pascal@17635 490
pascal@17635 491 _installtaz()
pascal@17635 492 {
pascal@20771 493 $DIALOG --clear --title " SliTaz TAZUSB way installation " \
pascal@17635 494 --yes-label "Install" --yesno \
pascal@17635 495 "\nSliTaz will be installed in the subdirectory \\slitaz of the current
paul@17935 496 Linux/DOS/Windows partition. You can see your files from /mnt/dos.\n\n
pascal@17635 497 You can start SliTaz with \\slitaz\\boot\\tazboot.exe\n\n
pascal@17635 498 To uninstall SliTaz, you have only to remove this directory.
pascal@17635 499 The file \\boot.ini or \\config.sys may be modified too.\n\n
pascal@17635 500 The filesystem is loaded entirely into memory upon boot to
paul@19451 501 increase responsiveness. Only /home lands on the hard disk.\n\n
pascal@17635 502 To do a traditional installation with disk partitioning,
pascal@20771 503 start SliTaz Live with the 'SliTaz RAM boot' menu.\n" 19 70
pascal@17635 504 [ $? -eq 0 ] || return
pascal@17635 505 doinstall tazusblike
pascal@17635 506 }
pascal@17635 507
pascal@17635 508 installtaz()
pascal@17635 509 {
pascal@17924 510 windev $1 || return
pascal@17635 511 packages_list=
pascal@17635 512 packages_dir=
pascal@17924 513 if [ "$1" ]; then
pascal@17924 514 doinstall tazusblike
pascal@17924 515 else
pascal@17924 516 _installtaz && bootinstalled /boot/bzimage
pascal@17924 517 fi
pascal@17635 518 umount $mnt
pascal@17635 519 rm -rf $mnt
pascal@17635 520 }
pascal@17635 521
pascal@17635 522 insttaz2zip()
pascal@17635 523 {
pascal@17924 524 if [ "$1" ]; then
pascal@17930 525 mkzip doinstall tazusblike
pascal@17924 526 else
pascal@17924 527 mkzip _installtaz
pascal@17924 528 fi
pascal@17635 529 }
pascal@17635 530
pascal@17635 531 bootiso()
pascal@17635 532 {
pascal@18799 533 cd /tmp
pascal@18240 534 for i in $(ls_r $media/boot/rootfs*gz); do
pascal@17635 535 grep -q ' lm ' /proc/cpuinfo && [ -s ${i}64 ] && i=${i}64
pascal@17635 536 cat $i
pascal@17635 537 n=$((4 - ($(stat -c %s $i) % 4)))
pascal@17635 538 [ $n -eq 4 ] || dd if=/dev/zero bs=1 count=$n
pascal@18799 539 done > initrd$$
pascal@18799 540 cmdline="root=/dev/null autologin lang=$LANG"
pascal@18799 541 [ -s /etc/keymap.conf ] && cmdline="$cmdline kmap=$(cat /etc/keymap.conf)"
pascal@18799 542 [ -s /etc/TZ ] && cmdline="$cmdline tz=$(cat /etc/TZ)"
pascal@18799 543 rm -f cmdline initrd 2> /dev/null
pascal@18799 544 getcustomconf kexec >/dev/null
pascal@18799 545 [ -s cmdline ] && cmdline="$cmdline $(cat cmdline)" && rm cmdline
pascal@18799 546 [ -s initrd ] && cat initrd >> initrd$$ && rm initrd
pascal@18240 547 kernel=$media/boot/bzImage
pascal@17635 548 grep -q ' lm ' /proc/cpuinfo && [ -s ${kernel}64 ] && kernel=${kernel}64
pascal@17635 549 . /etc/locale.conf
pascal@18799 550 kexec -l $kernel --initrd initrd$$ --command-line "$cmdline" &&
pascal@18799 551 rm -f initrd$$
pascal@18240 552 quit "kexec -e"
pascal@17635 553 }
pascal@17635 554
pascal@17635 555 tazboot()
pascal@17635 556 {
pascal@17928 557 if [ -z "$1" ]; then
pascal@20771 558 $DIALOG --clear --title " SliTaz bootloader for DOS " \
pascal@17928 559 --yes-label "Install" --yesno \
pascal@17635 560 "\nThe file TAZBOOT.EXE will be created in the top directory. It supports
pascal@17635 561 any linux kernel, multiple initramfs, a kernel command line and
pascal@17635 562 an ISO image file loopback (retrieves files from an ISO file).\n\n
pascal@20771 563 Usage: tazboot.exe [[@commands]|[kernel=<bzimage>]
pascal@17635 564 [initrd=<rootfs>[,<rootfs2>...]] [bootfrom=<isofile>] cmdline args ...]\n\n
pascal@17635 565 Defaults: tazboot @tazboot.cmd or tazboot kernel=bzImage auto\n\n\
pascal@17635 566 Examples for tazboot.cmd:\n\n\
pascal@17635 567 bootfrom=\\isos\\slitaz-4.0.iso\n\
pascal@17635 568 kernel=boot/bzImage\n\
pascal@17635 569 initrd=boot/rootfs4.gz,boot/rootfs3.gz,boot/rootfs2.gz,boot/rootfs1.gz\n\
pascal@17635 570 rw root=/dev/null autologin\n\n\
pascal@17635 571 kernel=\\slitaz\\vmlinuz root=/dev/sda5 ro\n\n
pascal@20771 572 Unlike GRUB4DOS, it doesn't require unfragmented ISO image files.\n" 0 0
pascal@17928 573 [ $? -eq 0 ] || return
pascal@17928 574 fi
pascal@17635 575 gettazboot tazboot.exe
pascal@19029 576 du -h $PWD/tazboot.exe
pascal@17635 577 }
pascal@17635 578
pascal@17635 579 md5()
pascal@17635 580 {
pascal@17635 581 dotwait "Checking files"
pascal@19432 582 ( cd $media ; ${md5sum:-md5sum -c md5sum*} 2>&1 | sort ) > /tmp/data
pascal@17928 583 unset md5sum
pascal@17635 584 rm -f /tmp/wait
pascal@17928 585 if [ "$1" ]; then
pascal@17924 586 cat /tmp/data
pascal@17924 587 else
pascal@20771 588 $DIALOG --clear --title " Checked files " \
pascal@18240 589 --textbox /tmp/data 0 0
pascal@17924 590 fi
pascal@17635 591 rm -f /tmp/data
pascal@17635 592 }
pascal@17635 593
pascal@17635 594 gotcdfile()
pascal@17635 595 {
pascal@18240 596 for i in "$media/$1" "$media/*/$1" "$media/*/isolinux/$1" ; do
pascal@17635 597 file=$(ls $i 2> /dev/null | sed q)
pascal@17635 598 [ -s "$file" ] && break
pascal@17635 599 done
pascal@17635 600 }
pascal@17635 601
pascal@17635 602 sha()
pascal@17635 603 {
pascal@17635 604 gotcdfile 'sha*sum*'
pascal@17635 605 sha=$(basename $file)
pascal@18240 606 md5sum="${sha%sum*}sum -c ${file#$media/}"
pascal@17928 607 md5 $@
pascal@17635 608 }
pascal@17635 609
pascal@17635 610 readme()
pascal@17635 611 {
pascal@17635 612 gotcdfile 'README*'
pascal@17924 613 if [ "$1" ]; then
pascal@17924 614 cat $file
pascal@17924 615 else
pascal@20771 616 $DIALOG --clear --title " Readme " --textbox $file 0 0
pascal@17924 617 fi
pascal@17635 618 }
pascal@17635 619
pascal@17635 620 bzimage()
pascal@17635 621 {
pascal@17928 622 if [ -z "$1" ]; then
pascal@20771 623 $DIALOG --clear --title " Create linux.exe ? " \
pascal@17924 624 --yes-label "Install" --yesno \
pascal@17635 625 "\nLinux.exe launches the linux kernel under DOS (in real mode only).
pascal@17635 626 The cmdline arguments are supported except initrd=,
pascal@17635 627 vga= (you can try 'rdev -v') and mem= (partially).
pascal@20771 628 \nExample:\nC:\\> linux.exe root=/dev/hda2 ro panic=60\n" 12 70
pascal@17924 629 [ $? -eq 0 ] || return
pascal@17924 630 fi
pascal@18240 631 cp $media/boot/bzImage linux.exe
pascal@19029 632 du -h $PWD/linux.exe
pascal@17635 633 }
pascal@17635 634
pascal@17635 635 memtest()
pascal@17635 636 {
pascal@17924 637 if [ -z "$1" ]; then
pascal@20771 638 $DIALOG --clear --title " Create memtest.exe ? " \
pascal@17924 639 --yes-label "Install" --yesno \
pascal@17635 640 "\nMemtest86 is a thorough, stand alone memory test for x86 architecture
pascal@17635 641 computers. BIOS based memory tests are a quick, cursory check and often
pascal@20771 642 miss many of the failures that are detected by Memtest86.\n" 0 0
pascal@17924 643 [ $? -eq 0 ] || return
pascal@17924 644 fi
pascal@17924 645 gotcdfile 'memtest*' && cp $file memtest.exe
pascal@19029 646 du -h $PWD/memtest.exe
pascal@17635 647 }
pascal@17635 648
pascal@17635 649 mkfat12()
pascal@17635 650 {
pascal@17635 651 [ $(($(get 0 $1) - 0x5A4D)) -eq 0 ] || return
pascal@17635 652 J=$(($(get 3 $1 1) + 0x02))
pascal@17635 653 R=$((1 + $(get 497 $1 1) + 1 + ($(get 500 $1)-1)/32))
pascal@17635 654 [ $R -lt 2500 ] || return
pascal@17635 655 [ $((($(get 500 $1)-1) & 31)) -lt 30 ] &&
pascal@17635 656 ddq if=$file bs=32 count=1 seek=$(($R*16 - 1)) of=/dev/fd0
pascal@17635 657 G="18 0 2 0 0 0 0 0"
pascal@17635 658 [ $J -gt 25 ] || G=""
pascal@17635 659 F=0
pascal@17635 660 for i in 1 2 3; do
pascal@17635 661 F=$((((2880-$R-$F-$F)*3+1023)/1024))
pascal@17635 662 done
pascal@17635 663 bytes2bin 0xEB $J 0x90 0x20 0x20 0x20 0x20 0x20 0x20 0x20 0x20 \
pascal@17635 664 0 2 2 $(($R%256)) $(($R/256)) 2 64 0 64 11 0xF0 $F 0 \
pascal@17635 665 $G | ddq bs=1 of=/dev/fd0
pascal@17635 666 ddq if=/dev/zero bs=512 count=$((4+$F+$F)) seek=$R of=/dev/fd0
pascal@17635 667 for i in $R $(($R+$F)) ; do
pascal@17635 668 bytes2bin 0xF0 0xFF 0xFF | ddq bs=512 seek=$i of=/dev/fd0
pascal@17635 669 done
pascal@17635 670 echo -n $(basename $1) | ddq bs=1 seek=3 count=8 of=/dev/fd0
pascal@17635 671 }
pascal@17635 672
pascal@17635 673 mkfloppy()
pascal@17635 674 {
pascal@17635 675 dotwait "Create a $(basename $1) boot floppy"
pascal@17635 676 ddq if=$1 of=/dev/fd0
pascal@17635 677 mkfat12 $1
pascal@17635 678 rm -f /tmp/wait
pascal@17635 679 }
pascal@17635 680
pascal@17635 681 fdmemtest()
pascal@17635 682 {
pascal@17924 683 if [ -z "$1" ]; then
pascal@20771 684 $DIALOG --clear --title " Create a Memtest86 boot floppy " \
pascal@17924 685 --yes-label "Create floppy" --yesno \
pascal@17635 686 "\nMemtest86 is a thorough, stand alone memory test for x86 architecture
pascal@17635 687 computers. BIOS based memory tests are a quick, cursory check and often
pascal@17635 688 miss many of the failures that are detected by Memtest86.\n\n
pascal@20771 689 Please insert a blank disk in floppy drive.\n" 0 0
pascal@17924 690 [ $? -eq 0 ] || return
pascal@17924 691 fi
pascal@17924 692 gotcdfile 'memtest*' && mkfloppy $file
pascal@17635 693 }
pascal@17635 694
pascal@17635 695 pxe()
pascal@17635 696 {
pascal@20762 697 gotcdfile '?pxe*'
pascal@17928 698 if [ -z "$1" ]; then
pascal@20771 699 $DIALOG --clear --title " Create $(basename $file).exe ? " \
pascal@17928 700 --yes-label "Install" --yesno \
pascal@17635 701 "\nBoot your operating system from the internet and enjoy a full system
pascal@17635 702 working entirely in RAM with speed and stability in mind. The Linux Kernel
pascal@17635 703 and the complete SliTaz compressed root filesystem will be loaded into RAM
pascal@20771 704 from the Web using PXE and HTTP protocols.\n" 0 0
pascal@17928 705 [ $? -eq 0 ] || return
pascal@17928 706 fi
pascal@17635 707 cp $file $(basename $file).exe
pascal@19029 708 du -h $PWD/$(basename $file).exe
pascal@17635 709 }
pascal@17635 710
pascal@17635 711 fdpxe()
pascal@17635 712 {
pascal@17924 713 if [ -z "$1" ]; then
pascal@20771 714 $DIALOG --clear --title " Create a SliTaz Web boot floppy " \
pascal@17924 715 --yes-label "Create floppy" --yesno \
pascal@17635 716 "\nBoot your operating system from the internet and enjoy a full system
pascal@17635 717 working entirely in RAM with speed and stability in mind. The Linux Kernel
pascal@17635 718 and the complete SliTaz compressed root filesystem will be loaded into RAM
pascal@17635 719 from the Web using PXE and HTTP protocols.\n\n
pascal@20771 720 Please insert a blank disk in floppy drive.\n" 0 0
pascal@17924 721 [ $? -eq 0 ] || return
pascal@17924 722 fi
pascal@20762 723 gotcdfile '?pxe*' && mkfloppy $file
pascal@17924 724 }
pascal@17924 725
pascal@17924 726 menuitem()
pascal@17924 727 {
pascal@17924 728 [ "$3" ] && shift
pascal@17924 729 echo -en "\"$1\" \"$2\""
pascal@17635 730 }
pascal@17635 731
pascal@17635 732 gotposixovl()
pascal@17635 733 {
pascal@19425 734 mount.posixovl 2>&1 | grep -qi usage && gotcdfile 'rootfs*.gz' &&
pascal@19425 735 menuitem "$@"
pascal@17635 736 }
pascal@17635 737
pascal@17635 738 gotposixovlzip()
pascal@17635 739 {
pascal@17635 740 [ "$(which zip)" ] && gotposixovl "$1" "$2"
pascal@17635 741 }
pascal@17635 742
pascal@17635 743 xfile()
pascal@17635 744 {
pascal@17924 745 [ "$(which $1)" ] && menuitem "$@"
pascal@17635 746 }
pascal@17635 747
pascal@17635 748 cdfile()
pascal@17635 749 {
pascal@17924 750 gotcdfile "$1" && menuitem "$@"
pascal@17635 751 }
pascal@17635 752
pascal@19425 753 gottazusb()
pascal@19425 754 {
pascal@19425 755 gotcdfile 'rootfs*.gz' && xfile tazusb "$@"
pascal@19425 756 }
pascal@19425 757
pascal@17659 758 isbzImage()
pascal@17659 759 {
pascal@17659 760 [ $(get 514 $file 4) -eq 1400005704 ] &&
pascal@17659 761 [ $(($(get 529 $file 1) & 1)) -eq 1 ]
pascal@17659 762 }
pascal@17659 763
pascal@17635 764 cdfilex()
pascal@17635 765 {
pascal@17924 766 gotcdfile "$1" && [ "$(which kexec)" ] && isbzImage && menuitem "$@"
pascal@17635 767 }
pascal@17635 768
pascal@17635 769 cdfilef()
pascal@17635 770 {
pascal@17635 771 [ -e /sys/block/fd0 ] && cdfile "$@"
pascal@17635 772 }
pascal@17635 773
pascal@17635 774 cdexe()
pascal@17635 775 {
pascal@17635 776 gotcdfile "$1" &&
pascal@17635 777 [ $(get 0 $file 2>/dev/null || echo 0) -eq 23117 ] &&
pascal@17924 778 menuitem "$@"
pascal@17635 779 }
pascal@17635 780
pascal@17635 781 misspkg()
pascal@17635 782 {
pascal@19029 783 for i in zip kexec-tools posixovl cdrkit cdrkit-isoinfo ; do
pascal@17635 784 [ -d /var/lib/tazpkg/installed/$i/ ] && continue
pascal@17924 785 [ "$1" != "install" ] && menuitem "$@" && return
pascal@17635 786 tazpkg get-install $i
pascal@17635 787 done
pascal@17635 788 }
pascal@17635 789
pascal@17635 790 missing()
pascal@17635 791 {
pascal@17635 792 misspkg install
pascal@17635 793 }
pascal@17635 794
pascal@17635 795 ishybrid()
pascal@17635 796 {
pascal@18670 797 [ $(get 510 "$ISO") -eq 43605 ] || return
pascal@18670 798 C=$((2048*$(get $(((17*2048) + 71)) "$ISO" 4)))
pascal@18670 799 [ $(get $C "$ISO" 4) -eq 1 ] || return
pascal@18670 800 [ $(get $(($C+30)) "$ISO" 4) -eq $((0x88AA55)) ] || return
pascal@18670 801 C=$((2048*$(get $(($C+40)) "$ISO" 4)))
pascal@18670 802 [ $(get $(($C+64)) "$ISO" 4) -eq 1886961915 ] && menuitem "$@"
pascal@17635 803 }
pascal@17635 804
pascal@17635 805 isiso()
pascal@17635 806 {
pascal@18670 807 [ $(get 32769 "$ISO" 4) -eq 808469571 ] && menuitem "$@"
pascal@18140 808 }
pascal@18140 809
pascal@18140 810 hastazboot()
pascal@18140 811 {
pascal@18670 812 [ $(get 0 "$ISO") -eq 23117 ] && menuitem "$@"
pascal@18034 813 }
pascal@18034 814
pascal@18034 815 burnable()
pascal@18034 816 {
pascal@19510 817 [ "$(sed '/Can wr.*1$/!d' /proc/sys/dev/cdrom/info 2> /dev/null)" ] &&
pascal@19510 818 menuitem "$@"
pascal@18034 819 }
pascal@18034 820
pascal@18034 821 blankable()
pascal@18034 822 {
pascal@19510 823 [ "$(sed '/Can wr.*RW.*1$/!d' /proc/sys/dev/cdrom/info 2> /dev/null)" ] &&
pascal@19510 824 menuitem "$@"
pascal@18034 825 }
pascal@18034 826
pascal@18034 827 burniso()
pascal@18034 828 {
pascal@18034 829 wodim -v speed=$(fgrep "drive speed" /proc/sys/dev/cdrom/info | cut -f3) \
pascal@18034 830 -eject -multi "$ISO"
pascal@18034 831 }
pascal@18034 832
pascal@18034 833 blankcd()
pascal@18034 834 {
pascal@18034 835 wodim -v -blank=fast
pascal@17635 836 }
pascal@17635 837
pascal@18675 838 customsector()
pascal@18675 839 {
pascal@19324 840 local c=$(echo $(get 32848 "$ISO" 4))
pascal@19324 841 hascustomconf $(($c+16)) && echo $(($c+16)) || echo $c
pascal@18675 842 }
pascal@18675 843
pascal@18675 844 hascustomconf()
pascal@18675 845 {
pascal@19324 846 [ "$(ddq bs=2k skip=${1:-$(customsector)} if="$ISO" | ddq bs=1 count=6)" \
pascal@18675 847 == "#!boot" ]
pascal@18675 848 }
pascal@18675 849
pascal@18675 850 gotcustomconf()
pascal@18675 851 {
pascal@18675 852 hascustomconf && menuitem "$@"
pascal@18675 853 }
pascal@18675 854
pascal@19425 855 hasflavor()
pascal@19425 856 {
pascal@19425 857 [ -x /usr/bin/tazlito ] && [ -s $media/boot/bzImage ] && menuitem "$@"
pascal@19425 858 }
pascal@19425 859
pascal@17635 860 gotisomd5()
pascal@17635 861 {
pascal@17635 862 [ "$(which md5sum 2> /dev/null)" ] &&
pascal@18670 863 [ $(get 0 "$ISO") -eq 23117 ] &&
pascal@18670 864 [ $(get 18 "$ISO") -ne 0 ] && menuitem "$@"
pascal@17635 865 }
pascal@17635 866
pascal@18675 867 getcustomconf()
pascal@18675 868 {
pascal@18675 869 ddq bs=2k skip=$(customsector) if="$ISO" | while read line; do
pascal@18675 870 case "$line" in
pascal@18675 871 \#!boot*) ;;
pascal@18675 872 append=*) echo ${line#append=} > cmdline && ls -l $PWD/cmdline ;;
pascal@18675 873 initrd:*) cnt=${line#initrd:}
pascal@18675 874 { ddq bs=512 count=$(($cnt / 512));
pascal@18675 875 ddq bs=1 count=$(($cnt % 512)); } > initrd &&
pascal@18675 876 ls -l $PWD/initrd
pascal@18675 877 break ;;
pascal@20771 878 *) break ;;
pascal@18675 879 esac
pascal@18675 880 done
pascal@18675 881 [ "$1" ] && return 0
pascal@18675 882 echo -e "\rPress RETURN to continue."
pascal@18675 883 read n
pascal@18675 884 }
pascal@18675 885
pascal@17635 886 isomd5()
pascal@17635 887 {
pascal@17635 888 dotwait "Checking iso image"
pascal@18670 889 [ "$(ddq if="$ISO" bs=2k skip=16 \
pascal@19323 890 count=$(($(get 32848 "$ISO" 4)-16)) | md5sum)" == \
pascal@18670 891 "$(ddq if="$ISO" bs=16 count=1 skip=2047 | od -N 16 -t x1 -An | \
pascal@17635 892 sed 's/ //g') -" ] && echo "OK" || echo "ERROR"
pascal@17635 893 echo -en "\rChecking iso hybrid boot..."
pascal@18671 894 n=$(($(get 2 "$ISO")-1+($(get 4 "$ISO")-1)*512))
pascal@17635 895 if [ $n -lt 40000 -a $n -gt 32768 ]; then
pascal@18670 896 s=$(get 0 "$ISO" 2 $n | awk '{ i+= $0 } END { print i }')
pascal@18670 897 [ $(((1+$s+$(get $(($n+1)) "$ISO" 1)) % 65536)) -eq 0 ] &&
pascal@17635 898 echo "OK" || echo "ERROR"
pascal@17635 899 fi
pascal@18675 900 if hascustomconf; then
pascal@18672 901 echo -en "\rChecking iso custom config..."
pascal@18672 902 TMP=/tmp/$(basename $0)$$md5
pascal@18675 903 md5="$(ddq bs=2k skip=$(customsector) if="$ISO" | while read line; do
pascal@18670 904 case "$line" in
pascal@18672 905 \#!boot*) echo ${line#*boot } > $TMP ;;
pascal@18670 906 append=*) echo $line ;;
pascal@18670 907 initrd:*) echo $line
pascal@18675 908 cnt=${line#initrd:}
pascal@18675 909 ddq bs=512 count=$((cnt / 512))
pascal@18675 910 ddq bs=1 count=$((cnt % 512))
pascal@18670 911 break ;;
pascal@20771 912 *) break ;;
pascal@18670 913 esac
pascal@18670 914 done | md5sum | cut -c1-32)"
pascal@18672 915 [ "$md5" == "$(cat $TMP)" ] && echo "OK" || echo "ERROR"
pascal@18672 916 rm -f $TMP
pascal@18670 917 fi
pascal@17635 918 rm -f /tmp/wait
pascal@17928 919 [ "$1" ] && return 0
pascal@17635 920 echo -e "\rPress RETURN to continue."
pascal@17635 921 read n
pascal@17635 922 }
pascal@17635 923
pascal@17635 924 usbdev()
pascal@17635 925 {
pascal@17635 926 dotwait "Wait 5 seconds for USB devices"
pascal@17635 927 sleep 5
pascal@17635 928 rm -f /tmp/wait
pascal@17635 929 DEV="$(grep -l 1 /sys/block/*/removable | \
pascal@17635 930 sed 's|/sys/block/\(.*\)/removable|\1|')"
pascal@17635 931 grep -qs 1 /sys/block/$DEV/ro && return
pascal@17635 932 [ "$DEV" ] || return
pascal@17635 933 cat > /tmp/dialog$$ <<EOT
pascal@20771 934 $DIALOG --clear --title " Select your USB key " \
pascal@17635 935 --menu "\nPlease select the USB key according to its known size.\n\n" \
pascal@18240 936 0 0 0 \
pascal@17635 937 $(for i in $DEV ; do
pascal@17635 938 echo -n "/dev/$i \"$(($(cat /sys/block/$i/size)/2048))MB $(cat /sys/block/$i/device/model 2> /dev/null)\" "
pascal@17635 939 done) \
pascal@17635 940
pascal@17635 941 EOT
pascal@17635 942 exec 3>&1
pascal@17635 943 device=$(. /tmp/dialog$$ 2>&1 1>&3)
pascal@17635 944 rm -f /tmp/dialog$$
pascal@17635 945 retval=$?
pascal@17635 946 exec 3>&-
pascal@17635 947 rm -f /tmp/dialog$$
pascal@17635 948 [ $retval -eq 0 ]
pascal@17635 949 }
pascal@17635 950
pascal@17635 951 tazusbmsg()
pascal@17635 952 {
pascal@17635 953 [ "$(which tazusb 2> /dev/null)" ] || return
pascal@17635 954 echo "You should choose 'USB key read/write installation' to be
pascal@17635 955 able to save the package updates or your own configuration and data files.\n\n"
pascal@17635 956 }
pascal@17635 957
pascal@17635 958 usbbootkey()
pascal@17635 959 {
pascal@17924 960 if [ -b "$1" ]; then
pascal@17924 961 device=$1
pascal@17928 962 elif [ "$1" ]; then
pascal@17928 963 echo "Invalid USB key device"
pascal@20771 964 return 1
pascal@17924 965 else
pascal@20771 966 $DIALOG --clear --title " Create a USB boot key " \
pascal@17924 967 --yes-label "Continue" --yesno \
pascal@17635 968 "\nThe USB key will be used like a CD-ROM. You will not be able to write
pascal@17635 969 any data on the boot partition.\n\n
pascal@17635 970 An extra FAT32 partition will be created with the remaining free space.\n\n
pascal@20771 971 $(tazusbmsg)Please plug your USB stick in now.\n" 16 70
pascal@17924 972 [ $? -eq 0 ] || return
pascal@17924 973 usbdev || return
pascal@17635 974
pascal@17924 975 # perform dd in progress bar
pascal@18670 976 max=$(($(stat -c %s "$ISO")/2048))
pascal@20771 977 i=0; ddq if="$ISO" bs=1024k | (
pascal@20771 978 while ddq bs=1024k count=1 ; do
pascal@17924 979 i=$(($i + 1))
pascal@17924 980 [ $i -gt $max ] && break
pascal@17924 981 echo $((($i*100)/$max)) | dialog --gauge \
pascal@17924 982 " The ISO image transfer can be long. Please wait..." \
pascal@17924 983 6 70 0 > /dev/tty 2>&1
pascal@17924 984 done ) > $device
pascal@17924 985 fi
pascal@17635 986
paul@17671 987 # partition + fat32 format for the remaining space
pascal@17860 988 for p in 0 16; do
pascal@17860 989 get $((450+$p)) $device 2 12 | xargs echo | {
pascal@17860 990 read dx cx ol oh ll lh
pascal@17860 991 [ $dx -eq $((0x3F17)) ] || continue
pascal@17635 992 cx=$(($cx & 0xFF00))
pascal@17635 993 ofs=$(($ll+($lh<<16)))
pascal@17635 994 n=$(($(cat /sys/block/${device#/dev/}/size)-$ofs))
pascal@17635 995 m=$(($cx+($n/8)))
pascal@17635 996 [ $m -gt $((0x3FF00)) ] && m=$((0x3FF00))
pascal@17635 997 m=$((($m & 0xFF00)+(($m>>16)<<6)))
pascal@17635 998 words2bin 0 $((0x101+$cx)) 0x3F0B $((32+$m)) \
pascal@17635 999 $ll $lh $(($n & 0xFFFF)) $(($n >> 16)) | \
pascal@17860 1000 ddq bs=1 seek=$((462-$p)) of=$device
pascal@17635 1001 if [ "$(which mkdosfs 2> /dev/null)" ]; then
pascal@17635 1002 losetup -o $((512*$ofs)) /dev/loop2 $device
pascal@17635 1003 mkdosfs -n "SLITAZ BOOT" /dev/loop2
pascal@17635 1004 words2bin $(($ofs & 0xFFFF)) $(($ofs >> 16)) | \
pascal@17635 1005 ddq bs=1 seek=28 of=/dev/loop2
pascal@17860 1006 sync
pascal@17635 1007 losetup -d /dev/loop2
pascal@17635 1008 fi
pascal@17860 1009 }
pascal@17860 1010 done
pascal@17635 1011 }
pascal@17635 1012
pascal@17635 1013 usbkey()
pascal@17635 1014 {
pascal@20771 1015 $DIALOG --clear --title " Create a SliTaz USB key " \
pascal@17635 1016 --yes-label "Continue" --yesno \
pascal@17635 1017 "\nUnlike a hard drive install, the filesystem is kept in a compressed
pascal@17635 1018 rootfs.gz. The filesystem is loaded entirely into memory upon boot.
pascal@17635 1019 This should increase responsiveness, protect the filesystem against
pascal@17635 1020 accidental corruption and reduce read/writes to the USB drive.
pascal@17635 1021 Once setup, the tazusb utility can rewrite the root filesystem
pascal@20771 1022 with any changes you have made since booting up,
pascal@17635 1023 giving the effective benefits of a hard drive install.\n\n
pascal@17635 1024 /home is mounted on boot using the UUID of your particular flash drive.
pascal@17635 1025 Unlike a device name, the UUID has the benefit of never changing from machine
pascal@17635 1026 to machine.\n\n
pascal@20771 1027 Please plug your USB stick in now.\n" 19 70
pascal@17635 1028 [ $? -eq 0 ] || return
pascal@17635 1029 usbdev || return
pascal@17635 1030 exec 3>&1
pascal@17635 1031 format=`$DIALOG --clear \
pascal@17635 1032 --title " Select the filesystem " \
pascal@17635 1033 --radiolist "\nPlease select the filesystem type to create.\n\n\
pascal@20771 1034 The filesystem creation will erase all the data in the USB key." 14 70 4 \
pascal@17635 1035 "none" "Do not erase the USB key" on \
pascal@17635 1036 "ext3" "Ext3 journaling filesystem" off \
pascal@17635 1037 "ext2" "Ext2 filesystem" off \
pascal@17635 1038 "fat32" "Windows FAT32 filesystem" off \
pascal@17635 1039 2>&1 1>&3`
pascal@17635 1040 retval=$?
pascal@17635 1041 exec 3>&-
pascal@17635 1042 [ $retval -eq 0 ] || return
pascal@17635 1043 [ "$format" != "none" ] && tazusb format $device "SliTaz" $format
pascal@18670 1044 tazusb gen-iso2usb "$ISO" $device
pascal@17635 1045 }
pascal@17635 1046
pascal@17635 1047 dokexec()
pascal@17635 1048 {
pascal@17659 1049 kexec -l $file || return
pascal@18240 1050 quit "kexec -e"
pascal@17635 1051 }
pascal@17635 1052
pascal@17635 1053 runmemtest()
pascal@17635 1054 {
pascal@17635 1055 gotcdfile 'memtest*' && dokexec
pascal@17635 1056 }
pascal@17635 1057
pascal@17635 1058 runpxe()
pascal@17635 1059 {
pascal@20762 1060 gotcdfile '?pxe*' && dokexec
pascal@17635 1061 }
pascal@17635 1062
pascal@17931 1063 flavdata()
pascal@17931 1064 {
pascal@18670 1065 [ $(get 1024 "$ISO") -eq 35615 ] && n=2 || n=$((1+$(get 417 "$ISO" 1)))
pascal@19425 1066 [ $n -eq 4 ] && n=20
pascal@20724 1067 [ $(get $(($n*512)) "$ISO") -eq 35615 ] || n=13
pascal@19510 1068 ddq if="$ISO" bs=512 skip=$n count=20 | zcat 2>/dev/null
pascal@17931 1069 }
pascal@17931 1070
pascal@17931 1071 hasflavinfo()
pascal@17931 1072 {
pascal@20724 1073 [ "$(flavdata | ddq bs=1 count=7 | strings)" == \
pascal@20724 1074 "0707010" ] && menuitem "$@"
pascal@17931 1075 }
pascal@17931 1076
pascal@17931 1077 showfavinfo()
pascal@17931 1078 {
pascal@17931 1079 mkdir -p /tmp/data
pascal@17931 1080 flavdata | ( cd /tmp/data ; cpio -i )
pascal@17931 1081 file=/tmp/data/info
pascal@17931 1082 cat /tmp/data/*desc > $file
pascal@18627 1083 if [ -s /tmp/data/*receipt ]; then
pascal@18627 1084 echo "=== receipt ==="
pascal@18627 1085 cat /tmp/data/*receipt
pascal@18627 1086 fi >> $file
pascal@17931 1087 for i in /tmp/data/*list* ; do
pascal@17931 1088 echo "=== extra ${i#*list} files"
pascal@17931 1089 cat $i
pascal@17931 1090 done >> $file
pascal@17931 1091 if [ "$1" ]; then
pascal@17931 1092 cat $file
pascal@17931 1093 else
pascal@20771 1094 $DIALOG --clear --title " Flavor info " \
pascal@18240 1095 --textbox $file 0 0
pascal@17931 1096 fi
pascal@17931 1097 rm -rf /tmp/data
pascal@17931 1098 }
pascal@17931 1099
pascal@18626 1100 flavor()
pascal@18626 1101 {
pascal@18626 1102 name="$(flavdata | cpio -t 2> /dev/null | sed 's/.[a-z]*$//;q')"
pascal@18626 1103 echo "Create ${name:=flavor}.flavor..."
pascal@18670 1104 tazlito iso2flavor "$ISO" $name
pascal@18771 1105 ls -l $name.flavor 2> /dev/null && return
pascal@18771 1106 sleep 5
pascal@18771 1107 [ "$1" ] && return
pascal@18771 1108 echo -e "\rPress RETURN to continue."
pascal@18771 1109 read n
pascal@18626 1110 }
pascal@18626 1111
pascal@18140 1112 if [ "$1" == "--build" ]; then #install-begin
pascal@18151 1113 uuencode -m - < ifmem.bin | sed -e '/^ifmemcode$/r/dev/stdin' \
pascal@18151 1114 -e '/^ifmemcode$/d' -i $0
pascal@18140 1115 uuencode -m - < bootloader.bin | sed -e '/^bootloader$/r/dev/stdin' \
pascal@18140 1116 -e '/^bootloader$/d' -e '/install-begin$/,/install-end$/d' -i $0
pascal@18140 1117 exit
pascal@18140 1118 fi #install-end
pascal@18140 1119 parse_isolinux()
pascal@18140 1120 {
pascal@18140 1121 awk 'BEGIN { IGNORECASE=1 }
pascal@18145 1122 function multi(n)
pascal@18145 1123 {
pascal@18145 1124 auto=$n
pascal@18145 1125 for (--n; n < NF; n+=2) {
pascal@18145 1126 s=$n
pascal@18145 1127 if (s ~ /M$/) s = substr(s,0,length(s)-1)
pascal@18145 1128 else s /= 1024
pascal@18145 1129 sizes=int(s) " " sizes
pascal@18145 1130 }
pascal@18145 1131 next
pascal@18145 1132 }
pascal@18140 1133 {
pascal@18140 1134 if ($1 == "LABEL") {
pascal@18140 1135 label=$2
pascal@18140 1136 if (auto == "") auto=label
pascal@18140 1137 }
pascal@18140 1138 if ($1 == "KERNEL" || $1 == "COM32") kernel[label]=$2
pascal@18140 1139 if ($1 == "INITRD") initrd[label]=$2
pascal@18140 1140 if ($1 == "APPEND") {
pascal@18140 1141 i=2
pascal@18145 1142 if (kernel[label] ~ "ifmem.c32") multi(3)
pascal@18140 1143 if (kernel[label] ~ "c32box.c32") {
pascal@18140 1144 if ($2 == "linux") { kernel[label]=$3; i=4 }
pascal@18145 1145 if ($2 == "ifmem") multi(4)
pascal@18140 1146 }
pascal@18140 1147 if (kernel[label] ~ "ifcpu64.c32") { auto=$4; next }
pascal@18140 1148 while (i <= NF) {
pascal@18140 1149 if ($i ~ "^initrd=") initrd[label]=substr($i,8)
pascal@18140 1150 else cmdline[label]=cmdline[label] " " $i
pascal@18140 1151 i++
pascal@18140 1152 }
pascal@18140 1153 }
pascal@18140 1154 }
pascal@18140 1155 END {
pascal@18140 1156 print "KERNEL=\"" kernel[auto] "\""
pascal@18140 1157 print "INITRD=\"" initrd[auto] "\""
pascal@18140 1158 print "CMDLINE=\"" substr(cmdline[auto],2) "\""
pascal@18145 1159 print "SIZES=\"" sizes "\""
pascal@18140 1160 }'
pascal@18140 1161 }
pascal@18140 1162
pascal@18140 1163 locase()
pascal@18140 1164 {
pascal@18140 1165 echo "$1" | tr [A-Z] [a-z]
pascal@18140 1166 }
pascal@18140 1167
pascal@18151 1168 ifmemcode()
pascal@18151 1169 {
pascal@18151 1170 uudecode <<EOT
pascal@18151 1171 ifmemcode
pascal@18151 1172 EOT
pascal@18151 1173 }
pascal@18151 1174
pascal@18140 1175 floppyset()
pascal@18140 1176 {
pascal@19425 1177 gotcdfile 'isolinux.cfg'
pascal@19432 1178 $0 include $file | parse_isolinux > /tmp/var$$
pascal@18140 1179 . /tmp/var$$
pascal@19425 1180 [ -z "$KERNEL" ] && echo "Can't parse isolinux.cfg" && return
pascal@18240 1181 for i in $media/$KERNEL $(dirname $file)/$KERNEL $media/$(locase $KERNEL) \
pascal@18240 1182 $(dirname $file)/$(locase $KERNEL); do
pascal@19433 1183 i="$(ls $i* | sed q)"
pascal@19433 1184 [ -n "$i" ] && KERNEL=$i && break
pascal@18240 1185 done
pascal@20771 1186 rm -f /tmp/var$$
pascal@18240 1187 [ $(get 514 $KERNEL 4) -eq 1400005704 ] || return
pascal@18240 1188 n=$(($(get 497 $KERNEL 1)+1))
pascal@18240 1189 ddq bs=512 count=$n if=$KERNEL of=/tmp/fd$$
pascal@18140 1190 uudecode <<EOT | ddq of=/tmp/fd$$ conv=notrunc
pascal@18140 1191 bootloader
pascal@18140 1192 EOT
pascal@18140 1193 pos=$(($n*512))
pascal@18140 1194 if [ -n "$CMDLINE" ]; then
pascal@18140 1195 echo -n "$CMDLINE" | ddq bs=512 count=1 conv=sync >> /tmp/fd$$
pascal@18140 1196 bytes2bin $n | ddq conv=notrunc \
pascal@18140 1197 bs=1 seek=497 count=1 of=/tmp/fd$$
pascal@18140 1198 words2bin $pos | ddq conv=notrunc \
pascal@18140 1199 bs=1 seek=34 count=2 of=/tmp/fd$$
pascal@18240 1200 [ $(get 518 $KERNEL 4) -ge 514 ] &&
pascal@18155 1201 words2bin 32768 9 | ddq conv=notrunc \
pascal@18140 1202 bs=1 seek=552 count=4 of=/tmp/fd$$
pascal@18140 1203 fi
pascal@18140 1204 syssize=$(echo $(get 500 /tmp/fd$$ 4))
pascal@18240 1205 ddq bs=512 skip=$n if=$KERNEL | cat - /dev/zero | \
pascal@18155 1206 ddq bs=512 count=$((($syssize+31)/32)) conv=sync >> /tmp/fd$$
pascal@18140 1207 base=$(stat -c %s /tmp/fd$$)
pascal@18140 1208 len=
pascal@18140 1209 if [ "$INITRD" ]; then
pascal@18140 1210 l=0
pascal@18140 1211 for i in ${INITRD//,/ }; do
pascal@18240 1212 for j in $media/$i $(dirname $KERNEL)/$i $media/$(locase $i) \
pascal@18240 1213 $(dirname $KERNEL)/$(locase $i); do
pascal@19433 1214 j="$(ls $j* | sed q)"
pascal@19433 1215 [ -n "$j" ] && i=$j && break
pascal@18240 1216 done
pascal@18240 1217 ddq if=$i >> /tmp/fd$$
pascal@18240 1218 l=$(($l+$(stat -c %s $i)))
pascal@18140 1219 r=$((4 - ($l % 4)))
pascal@18140 1220 if [ $r -ne 4 ]; then
pascal@18140 1221 ddq if=/dev/zero bs=1 count=$r >> /tmp/fd$$
pascal@18140 1222 l=$(($l + $r))
pascal@18140 1223 fi
pascal@18143 1224 case "$i:$INITRD" in
pascal@18143 1225 *rootfs.gz:*rootfs.gz,*) continue # loram
pascal@18140 1226 esac
pascal@18140 1227 len="$len $l"; l=0
pascal@18140 1228 done
pascal@18143 1229 rdadrs=${RDADRS:-$(((($syssize*16)+0x1F0000) & -4096))}
pascal@18140 1230 words2bin $(($rdadrs & 0xFFFF)) $(($rdadrs >> 16)) | ddq \
pascal@18140 1231 conv=notrunc bs=1 seek=536 count=4 of=/tmp/fd$$
pascal@18140 1232 fi
pascal@18140 1233 n=$(echo $len | wc -w)
pascal@18140 1234 if [ $((494 - $(get 494 /tmp/fd$$))) -ge $(($n * 4)) ]; then
pascal@18140 1235 i=$(($(get 494 /tmp/fd$$)))
pascal@18140 1236 bytes2bin $(($i + ($n*4) - 256)) | ddq bs=1 conv=notrunc \
pascal@18140 1237 seek=496 count=1 of=/tmp/fd$$
pascal@18140 1238 else
pascal@18140 1239 i=$(($pos + 0x1FC - ($n*4)))
pascal@18140 1240 bytes2bin $(($i % 256)) $((i / 256)) 252 | ddq bs=1 \
pascal@18140 1241 conv=notrunc seek=494 count=3 of=/tmp/fd$$
pascal@18151 1242 s=$(($i - 2*$(echo "$SIZES" | wc -w)))
pascal@18151 1243 p=$(($s - $(ifmemcode | wc -c)))
pascal@18151 1244 ifmemcode | ddq bs=1 conv=notrunc seek=$p of=/tmp/fd$$
pascal@18151 1245 words2bin $SIZES | ddq bs=1 conv=notrunc seek=$s of=/tmp/fd$$
pascal@18151 1246 bytes2bin 154 $(($p%256)) $(($p/256)) 0 144 | \
pascal@18151 1247 ddq bs=1 conv=notrunc seek=60 of=/tmp/fd$$
pascal@18140 1248 fi
pascal@18140 1249 for r in $len ; do
pascal@18140 1250 words2bin $(($r & 0xFFFF)) $(($r >> 16)) | ddq conv=notrunc \
pascal@18140 1251 bs=1 seek=$i count=4 of=/tmp/fd$$
pascal@18140 1252 i=$(($i + 4))
pascal@18140 1253 done
pascal@18140 1254 split -b 1440k /tmp/fd$$ fd$$
pascal@18140 1255 rm -f /tmp/fd$$
pascal@18140 1256 n=1; i=0; r=0
pascal@18140 1257 set -- $len
pascal@18140 1258 ls fd$$* | while read file ; do
pascal@18140 1259 if [ $i -gt $(($1+$base)) ]; then
pascal@18140 1260 shift
pascal@18140 1261 r=$(($r+100)); n=0; i=0; base=0
pascal@18140 1262 fi
pascal@18140 1263 ddq of=$file bs=18k seek=80 count=0
pascal@18140 1264 i=$(($i+1474560))
pascal@18140 1265 printf "mv %s fd%03d.img\n" $file $(($r+$n))
pascal@18140 1266 n=$(($n+1))
pascal@18140 1267 done | sh
pascal@19029 1268 du -ch $PWD/fd???.img
pascal@18140 1269 }
pascal@18140 1270
pascal@17635 1271 quit()
pascal@17635 1272 {
pascal@18240 1273 umount -d $media
pascal@18240 1274 rmdir $media
pascal@18240 1275 ${1:-exit}
pascal@17635 1276 }
pascal@17635 1277
pascal@19008 1278 infoiso()
pascal@19008 1279 {
pascal@19008 1280 isoinfo -d -i "$ISO" > /tmp/isoinfo$$
pascal@19008 1281 if [ -x "$(which iso2exe)" ]; then
pascal@19008 1282 echo "----"
pascal@20159 1283 blkid "$ISO" | while read args; do
pascal@20159 1284 set -- $args
pascal@20159 1285 while [ -n "$2" ]; do
pascal@20159 1286 case "$2" in
pascal@20159 1287 *UUID*|PT*) echo $2;;
pascal@20159 1288 esac
pascal@20159 1289 shift
pascal@20159 1290 done
pascal@20159 1291 done
pascal@20159 1292 if ! fdisk -l "$ISO" | grep -q 'valid partition'; then
pascal@20159 1293 fdisk -l "$ISO" | grep heads
pascal@20159 1294 fdisk -l "$ISO" | sed 's/^ *[^ ]* *//;s/ */ /g;$!d'
pascal@20159 1295 fi
pascal@20159 1296 echo "----"
pascal@19008 1297 iso2exe -l "$ISO"
pascal@19008 1298 fi >> /tmp/isoinfo$$
pascal@19008 1299 if [ "$1" ]; then
pascal@19008 1300 cat /tmp/isoinfo$$
pascal@19008 1301 else
pascal@20771 1302 $DIALOG --clear --title " Info ISO " \
pascal@19008 1303 --textbox /tmp/isoinfo$$ 0 0
pascal@19008 1304 fi
pascal@19008 1305 rm -f /tmp/isoinfo$$
pascal@19008 1306 }
pascal@19008 1307
pascal@18289 1308 isotitle()
pascal@18289 1309 {
pascal@18778 1310 echo "$(blkid "$ISO" | sed 's/.*LABEL="\([^"]*\).*/\1/') $(stat \
pascal@18778 1311 -c %y $media/.|sed 's/ .*//') $(basename "$ISO")"
pascal@18289 1312 }
pascal@18289 1313
pascal@19432 1314 if [ "$1" == "include" ]; then
pascal@19432 1315 [ -s "$2" ] && cd $(dirname "$2") && awk -v exe=$0 \
pascal@19432 1316 '{ if ($1 == "include") system(exe " include " $2); else print }' <"$2"
pascal@19432 1317 exit
pascal@19432 1318 fi
pascal@18034 1319 ISO="${1:-/dev/null}"
pascal@20620 1320 [ ${ISO:0:1} != "/" ] && ISO=$(cd $(dirname $ISO); echo $PWD/$(basename $ISO))
pascal@17635 1321 [ -z "$(isiso 2> /dev/null)" ] && echo "Usage : $0 file.iso" && exit 1
pascal@18666 1322 media=/tmp/media$$
pascal@18240 1323 mkdir -p $media
pascal@18670 1324 mount -o loop,ro "$ISO" $media
pascal@17635 1325
pascal@17928 1326 if [ "$2" == "list" ]; then
pascal@17928 1327 sed '/^\$(.*") \\/!d;s/^\$(\(.*\)").*/\1"/' $0 | while read line; do
pascal@17928 1328 eval $line
pascal@17928 1329 echo
pascal@17928 1330 done | sed '/^$/d;/"usbkey"/d'
pascal@17928 1331 quit
pascal@17928 1332 fi
pascal@17924 1333 if grep -q "^$2()" $0; then
pascal@17924 1334 exe=$2
pascal@17924 1335 shift 2
pascal@18140 1336 if [ -n "$(eval $(grep "\"$exe\"" $0 | sed \
pascal@18140 1337 '/^\$/!d;s/.(\(.*\)[\t ]*".*"[\t ]*".*/\1/'))" ]; then
pascal@18289 1338 isotitle
pascal@17924 1339 grep "\"$exe\"" $0 | sed '/^\$/!d;s/.*"[\t ]*"\(.*\)".*/\1/'
pascal@18140 1340 echo ----
pascal@17924 1341 $exe "$@"
pascal@17924 1342 fi
pascal@17924 1343 quit
pascal@17924 1344 fi
pascal@17924 1345
pascal@17635 1346 while true; do
pascal@17635 1347 cat > /tmp/dialog$$ <<EOT
pascal@20771 1348 $DIALOG --clear --title " $(isotitle) " --menu "" -2 70 0 \
pascal@17635 1349 $(cdfile 'README*' "readme" "Show the README file") \
pascal@18675 1350 $(gotcustomconf "getcustomconf" "Get custom config") \
pascal@17635 1351 $(gotisomd5 "isomd5" "Check the ISO image") \
pascal@17635 1352 $(cdfile 'md5sum*' "md5" "Check the ISO files") \
pascal@17635 1353 $(cdfile 'sha*sum*' "sha" "Check the ISO files") \
pascal@19008 1354 $(xfile isoinfo "infoiso" "ISO image info") \
pascal@17635 1355 $(cdfilex boot/bzImage "bootiso" "Boot the ISO image") \
pascal@18034 1356 $(burnable "burniso" "Burn the ISO image") \
pascal@18034 1357 $(blankable "blankcd" "Blank the CD/DVD") \
pascal@17635 1358 $(gotposixovl "install" "Hard disk installation (UMSDOS way)") \
pascal@17635 1359 $(gotposixovl "installtaz" "Hard disk installation (TAZUSB way)") \
pascal@17635 1360 $(gotposixovlzip "inst2zip" "ZIP installation archive (UMSDOS way)") \
pascal@17635 1361 $(gotposixovlzip "insttaz2zip" "ZIP installation archive (TAZUSB way)") \
pascal@19425 1362 $(gottazusb "usbkey" "USB key read/write installation") \
pascal@17635 1363 $(ishybrid "usbbootkey" "USB boot key (read only)") \
paul@17935 1364 $(hasflavinfo "showfavinfo" "Show flavor extra info") \
pascal@19425 1365 $(hasflavor "flavor" "Get flavor file") \
pascal@18140 1366 $(cdfile isolinux.cfg "floppyset" "Boot floppy set") \
pascal@18140 1367 $(hastazboot "tazboot" "Get tazboot.exe Linux loader") \
pascal@17635 1368 $(cdexe boot/bzImage "bzimage" "Get linux DOS/EXE file") \
pascal@17635 1369 $(cdexe 'memtest*' "memtest" "Get Memtest86 DOS/EXE file") \
pascal@17635 1370 $(cdfilef 'memtest*' "fdmemtest" "Create a Memtest86 boot floppy") \
pascal@17635 1371 $(cdfilex 'memtest*' "runmemtest" "Start Memtest86") \
pascal@20724 1372 $(cdexe '?pxe*' "pxe" "Get SliTaz Web boot DOS/EXE utility") \
pascal@20724 1373 $(cdfilef '?pxe*' "fdpxe" "Create a SliTaz Web boot floppy") \
pascal@20724 1374 $(cdfilex '?pxe*' "runpxe" "Start the SliTaz Web boot utility") \
pascal@17635 1375 $(misspkg "missing" "Install packages to get more options") \
pascal@17924 1376 $(menuitem "quit" "Quit this utility")
pascal@17635 1377 EOT
pascal@17635 1378 exec 3>&1
pascal@17635 1379 value=$(. /tmp/dialog$$ 2>&1 1>&3)
pascal@17635 1380 retval=$?
pascal@17635 1381 exec 3>&-
pascal@17635 1382 rm -f /tmp/dialog$$
pascal@18771 1383 [ $retval -eq 0 ] || quit
pascal@17635 1384 $value
pascal@17635 1385 done